AppTitle "Dragon Fire"
AskForStartLevel

SeedRnd MilliSecs()
Graphics 320,240
SetBuffer BackBuffer()
TFormFilter 0

;GRAPHICS HANDLES

Global DragonNeck=LoadImage("Gfx\dragon-neck.png")
Global Ground=LoadImage("Gfx\ground.png")
Global Castle=LoadImage("Gfx\castle.png")
Global BackGroundScene=LoadImage("Gfx\background.png")
Global DragonMouthGlow=LoadAnimImage("Gfx\dragonmouthglow.png",19,19,0,4)
Global Fireballs=LoadAnimImage("Gfx\fireballs.png",19,19,0,10)
Global Particles=LoadAnimImage("Gfx\particles.png",5,5,0,27)
Global Gargoyles=LoadAnimImage("Gfx\gargs.png",13,13,0,18)
Global Wyverns=LoadAnimImage("Gfx\wyverns.png",50,50,0,22)
Global WyvernBomb=LoadImage("Gfx\wyvernbomb.png")
Global Gryphons=LoadAnimImage("Gfx\gryphons.png",55,55,0,34)
Global SmallNumbers=LoadAnimImage("Gfx\numbers-small.png",10,10,0,10)
Global LargeNumbers=LoadAnimImage("Gfx\numbers-large.png",40,40,0,10)
Global TextLevel=LoadImage("Gfx\text-level.png")
Global TextComplete=LoadImage("Gfx\text-complete.png")
Global TextBonusStage=LoadImage("Gfx\text-bonusstage.png")
Global TextFinalLevel=LoadImage("Gfx\text-finallevel.png")
Global TextGameOver=LoadImage("Gfx\text-gameover.png")
Global TextWellDone=LoadImage("Gfx\text-welldone.png")
Global LysoLogo=LoadImage("Gfx\lysologo.png")
Global DragonFireTitle=LoadImage("Gfx\dragonfiretitle.png")
Global BonusObjects=LoadAnimImage("Gfx\bonustargets.png",25,25,0,80)

MidHandle DragonNeck
MidHandle DragonMouthGlow
MidHandle Fireballs
MidHandle Particles
MidHandle Gargoyles
MidHandle BonusObjects
MidHandle Wyverns
MidHandle WyvernBomb
MidHandle Gryphons

;SOUND AND MUSIC HANDLES

Global MusicLevelIntro=LoadSound("Audio\music-levelintro.mp3")
Global MusicGameOver=LoadSound("Audio\music-gameover.mp3")
Global MusicLevels1to3=LoadSound("Audio\music-levels1-3.mp3")
Global MusicLevels4to6=LoadSound("Audio\music-levels4-6.mp3")
Global MusicLevels7to9=LoadSound("Audio\music-levels7-9.mp3")
Global MusicFinalLevel=LoadSound("Audio\music-finallevel.mp3")
Global MusicGameWon=LoadSound("Audio\music-gamewon.mp3")
Global MusicBonus1=LoadSound("Audio\music-bonus1.mp3")
Global MusicBonus2=LoadSound("Audio\music-bonus2.mp3")
Global MusicBonus3=LoadSound("Audio\music-bonus3.mp3")
Global LevelVictorySong=LoadSound("Audio\music-victory.mp3")
Global FireShoot=LoadSound("Audio\fireshoot.wav")
Global GargoylePlop=LoadSound("Audio\gargoyleplop.wav")
Global GargoyleLaugh=LoadSound("Audio\gargoylelaugh.wav")
Global BigDragonExplosion=LoadSound("Audio\bigdragonexplosion.mp3")
Global SoftFireWork=LoadSound("Audio\softfirework.wav")
Global LoudFireWork=LoadSound("Audio\loudfirework.wav")
Global FallingBomb=LoadSound("Audio\fallingbomb.mp3")
Global GargoyleScream=LoadSound("Audio\gargoylescream.wav")
Global GargoyleTaunt1=LoadSound("Audio\gargoyletaunt1.mp3")
Global GargoyleTaunt2=LoadSound("Audio\gargoyletaunt2.mp3")
Global GargoyleTaunt3=LoadSound("Audio\gargoyletaunt3.mp3")
Global GryphonSquawk=LoadSound("Audio\gryphonsquawk.mp3")
Global GryphonDeath=LoadSound("Audio\gryphondeath.mp3")

;GLOBAL VARIABLES

Global FrameTimer,MusicTimer,MusicChannel,GargScreamChannel,Gravity#,MaxParticles,GameFrameTimer,PauseTimer
Global DragonDeathTimer,DragonDead,LevelDisplayTimer,LevelVictoryTimer,BonusLevelTimer,MaxBonusObj,MaxBonusLevelTimer
Global TrueGameLevel,GameLevel,BonusLevel,Score,DragonFire,GargoylesLeft
Global DragonAngle,MaxFireballs,FireballSpeed,MaxGargoyles
Global GameWon,GameWonTimer,AskingTrueGameLevel

;FONTS

Global TitleFont=LoadFont("Arial",20,True,False,False)

;TYPES

Type DragonPathType
	Field x#,y#
End Type

Type FireballType
	Field x#,y#,mx#,my#,frame,frametimer,dying,exist
End Type

Type ParticleType
	Field x#,y#,mx#,my#,typ,frame,frametimer,exist
End Type

Type GargoyleType
	Field x#,y#,my#,hp,frame,frametimer,exist,flaming
End Type

Type WalkGargoyleType
	Field x#,y#,frame,frametimer,exist,inplace
End Type

Type BonusObjType
	Field x#,y#,mx#,my#,frame,frametimer,exist,hp,typ
End Type

Type BombType
	Field x#,y#,mx#,my#,exist,hp
End Type

Type WyvernType
	Field x#,y#,my#,dying,hp,frame,frametimer,dir,holdbomb,exist		;1=going right, 2=going left
End Type

Type GryphonType
	Field x#,y#,mx#,my#,dying,exist,hp
	Field flaptimer,flapframe,swerve,swervetimer				;swerve is 1,2,3,4,5
End Type

Type LevelGargsInfoType
	Field Number,Minspeed#,Maxspeed#,Chance
End Type

;ARRAYS

Dim DragonPath.DragonPathType(161,4)			;1-3=Neck Segments, 4=Head
Dim DragonHead(161)
Dim Fireball.FireballType(100)
Dim Particle.ParticleType(2000)
Dim Gargoyle.GargoyleType(200)
Dim NumInPlaceGarg(2)							;1=Left side, 2=Right side
Dim WalkGarg.WalkGargoyleType(2,4)
Dim BonusObj.BonusObjType(100)
Dim Bomb.BombType(5)
Dim Wyvern.WyvernType(5)
Dim Gryphon.GryphonType(5)
Dim LevelGargsInfo.LevelGargsInfoType(10)

;DATA
;Number of gargoyles,min speed, max speed

.LevelGargsData
Data 80,0.5,0.7,20
Data 120,0.6,1.0,16
Data 200,0.8,1.2,13
Data 100,0.5,0.8,18
Data 130,0.6,0.9,16
Data 180,0.4,1.0,16
Data 100,0.5,0.7,22
Data 120,0.6,0.8,19
Data 150,0.5,0.7,17
Data 1000,0.2,0.5,8

;START MAIN GAME

Initialize
InitializeDragonHead

GameTitle

StartNewLevel
FlushKeys

.MainGameLoop
	
	DragonFire=0
	
	If KeyDown(1) Then End
	
	;Right
	If KeyDown(205) Then
		DragonAngle=DragonAngle+2
		If DragonAngle>161 Then DragonAngle=161
	EndIf
	
	;Left
	If KeyDown(203) Then
		DragonAngle=DragonAngle-2
		If DragonAngle<1 Then DragonAngle=1
	EndIf

	If KeyDown(57) Then AddFireBall
	
	kkk=GetKey()
	If kkk=Asc("p") Or kkk=Asc("P") Then PauseGame
	
	;ADD A RANDOM ENEMY OR BONUS OBJECT
	If GameLevel<>0 Then
		If Rand(1,LevelGargsInfo(GameLevel)\Chance)=1 And MusicTimer>=3 Then AddGameLevelGargoyle
	EndIf
	If Rand(1,20)=1 And MusicTimer>=3 Then AddGameLevelBonusObj
	If Rand(1,900)=1 And MusicTimer>=3 Then AddGameLevelWyvern
	If Rand(1,400)=1 And MusicTimer>=3 Then AddGameLevelGryphon
	
	If DragonDeathTimer>0 Then DragonDeathSequenceByGargoyles
	If LevelVictoryTimer>0 Then LevelVictorySequence
	
	LevelOver
	
	
	;DISPLAY ALL OBJECTS
	
	WaitTimer(GameFrameTimer)
	Cls
	DrawBlock BackGroundScene,0,0
	UpdateParticles
	UpdateGargoyles
	UpdateBombs
	UpdateWyverns
 	UpdateGryphons
	UpdateWalkingGargoyles
	UpdateBonusObj
	UpdateFireballs
	DrawDragon
	DrawScenery
	DisplayScore
	If LevelDisplayTimer<250 Then DisplayCurrentLevel
	GameOver
	GameWon
	
	If LevelVictoryTimer>100 And LevelVictoryTimer<750 Then
		If GameLevel<>0 Then 
			DrawImage TextLevel,85,40
			level=GameLevel
			For a=1 To Len(Str level)
				nasc=Asc(Mid$(Str level,a,1))
				nasc=nasc-48
				DrawImage LargeNumbers,170+(a*35),40,nasc
			Next
			DrawImage TextComplete,45,85
		EndIf
		If BonusLevel<>0 Then 
			DrawImage TextBonusStage,30,40
			DrawImage TextComplete,45,85
		EndIf
	EndIf
	
	Flip
	
	PlayMusic
	
Goto MainGameLoop

Function AskForStartLevel()
	Cls
	Print"Values:"
	Print"1....Game Level 1"
	Print"2....Game Level 2"
	Print"3....Game Level 3"
	Print"4....Bonus Level 1"
	Print"5....Game Level 4"
	Print"6....Game Level 5"
	Print"7....Game Level 6"
	Print"8....Bonus Level 2"
	Print"9....Game Level 7"
	Print"10...Game Level 8"
	Print"11...Game Level 9"
	Print"12...Bonus Level 3"
	Print"13...Game Level 10"
	Print:Print
	
	.Asking
	Ask=Input("Select: ")
	
	If Ask>13 Or Ask<1 Then Goto Asking
	
	TrueGameLevel=Ask-1
	AskingTrueGameLevel=TrueGameLevel
	
End Function

Function GameTitle()
	Local SineCount=0
	SetFont TitleFont
	
	;DrawImageRect image,x,y,rect_x,rect_y,rect_width,rect_height,[frame] 
	While Not KeyDown(57)

	If Rand(1,10)=1 Then 
		AddExplosion(Rand(0,319),Rand(0,239),100,4,1,4)
		PlaySound SoftFireWork
	EndIf
	
	
	;DRAW STUFF
	
	WaitTimer(GameFrameTimer)
	Cls
	
	UpdateParticles
	
	For t=0 To ImageWidth(DragonFireTitle)-1
		DrawImageRect DragonFireTitle,53+t,10+(Sin(SineCount+t)*5),t,0,1,ImageHeight(DragonFireTitle)
	Next
	SineCount=SineCount+5
	If SineCount>359 Then SineCount=SineCount-360
	
	Color 255,255,255
	Text 60,130,"PRESS SPACE TO PLAY"
	Text 75,220,"(C) 2002 LYSOZYME"
	DrawImage LysoLogo,130,165
	
	Flip
	
	Wend
End Function

Function Initialize()
;Initialize Paths of Dragon Segments
	For ang=1 To 161
		tempang#=ang-81
		For seg=1 To 4
			DragonPath.DragonPathType(ang,seg)=New DragonPathType
			If seg=1 Then adj#=0.25
			If seg=2 Then adj#=0.6
			If seg=3 Then adj#=0.85
			If seg=4 Then adj#=1
			DragonPath(ang,seg)\x=159+Sin(tempang*adj)*(5+(10*(seg-1)))
			Dragonpath(ang,seg)\y=199-Cos(tempang*adj)*(5+(10*(seg-1)))
		Next
	Next
	;TrueGameLevel=4                                     ;BONUS: 3,7,11
	GameLevel=0
	TrueGameLevel=AskingTrueGameLevel
	BonusLevel=0
	BonusLevelTimer=0
	Score=0
	GameWon=0
	GameWonTimer=0
	LevelDisplayTimer=0
	DragonAngle=80
	MaxFireballs=100
	FireballSpeed=3
	MaxParticles=2000
	MusicTimer=1
	Gravity=0.05
	MaxGargoyles=200
	DragonDeathTimer=0
	DragonDead=0
	DragonFire=0
	GargoylesLeft=0
	LevelVictoryTimer=0
	MaxBonusObj=100
	MaxBonusLevelTimer=2200
	GameFrameTimer=CreateTimer(60)
	For a=1 To MaxFireBalls
		Fireball.FireballType(a)=New FireballType
		Fireball(a)\exist=0
	Next
	For a=1 To MaxParticles
		Particle.ParticleType(a)=New ParticleType
		Particle(a)\exist=0
	Next
	For a=1 To MaxGargoyles
		Gargoyle.GargoyleType(a)=New GargoyleType
		Gargoyle(a)\exist=0
	Next
	For a=1 To 2
		For b=1 To 4
			WalkGarg.WalkGargoyleType(a,b)=New WalkGargoyleType
			WalkGarg(a,b)\exist=0
		Next
	Next
	NumInPlaceGarg(1)=0:NumInPlaceGarg(2)=0
	For a=1 To MaxBonusObj
		BonusObj.BonusObjType(a)=New BonusObjType
		BonusObj(a)\exist=0
	Next
	For a=1 To 5
		Bomb.BombType(a)=New BombType
		Wyvern.WyvernType(a)=New WyvernType
		Gryphon.GryphonType(a)=New GryphonType
		Bomb(a)\exist=0:Wyvern(a)\exist=0:Gryphon(a)\exist=0
	Next
	Restore LevelGargsData
	For a=1 To 10
		LevelGargsInfo.LevelGargsInfoType(a)=New LevelGargsInfoType
		Read LevelGargsInfo(a)\Number
		Read LevelGargsInfo(a)\Minspeed
		Read LevelGargsInfo(a)\Maxspeed
		Read LevelGargsInfo(a)\Chance
	Next
End Function

Function InitializeDragonHead()
	DragonHead(0)=LoadImage("Gfx\dragon-head.png")
	For ang=1 To 161
		tempang=ang-81
		DragonHead(ang)=CopyImage(DragonHead(0))
		HandleImage DragonHead(ang),12,16
		RotateImage DragonHead(ang),tempang
	Next		
End Function

Function DrawScenery()
	DrawImage Castle,139,195
	DrawImage Ground,0,230
End Function

Function DisplayScore()
	sco$=Str score
	For s=1 To Len(sco$)
		nasc=Asc(Mid$(sco$,s,1))
		nasc=nasc-48
		DrawImage SmallNumbers,280+(s*6),0,nasc
	Next	
End Function

Function DisplayCurrentLevel()	
	LevelDisplayTimer=LevelDisplayTimer+1
	If LevelDisplayTimer>300 Then LevelDisplayTimer=300
	If GameLevel<>0 Then
		DrawImage TextLevel,80,70
		If GameLevel=10 Then DrawImage TextFinalLevel,50,30
		level=GameLevel
		For a=1 To Len(Str level)
			nasc=Asc(Mid$(Str level,a,1))
			nasc=nasc-48
			DrawImage LargeNumbers,165+(a*30),70,nasc
		Next
	EndIf
	
	If BonusLevel<>0 Then
		DrawImage TextBonusStage,30,70
	EndIf
	
End Function
	
	
Function PlayMusic()
	If DragonDeathTimer>0 Then Return
	If LevelVictoryTimer>100 Then Return
	If GameWon=1 Then Return
	
	If MusicTimer=1 Then
		If ChannelPlaying(MusicChannel)=0 Then
			MusicChannel=PlaySound(MusicLevelIntro)
			MusicTimer=2
		EndIf
	EndIf
	
	If MusicTimer=2 Or MusicTimer=3 Then
		If ChannelPlaying(MusicChannel)=0 Then 
			MusicTimer=3
			ChannelVolume MusicChannel,1
			If GameLevel=10 Then MusicChannel=PlaySound(MusicFinalLevel)
			If GameLevel>=1 And GameLevel<=3 Then MusicChannel=PlaySound(MusicLevels1to3)
			If GameLevel>=4 And GameLevel<=6 Then MusicChannel=PlaySound(MusicLevels4to6)
			If GameLevel>=7 And GameLevel<=9 Then MusicChannel=PlaySound(MusicLevels7to9)
			
			If BonusLevel=1 Then MusicChannel=PlaySound(MusicBonus1)
			If BonusLevel=2 Then MusicChannel=PlaySound(MusicBonus2)
			If BonusLevel=3 Then MusicChannel=PlaySound(MusicBonus3)
			If BonusLevel<>0 Then MusicTimer=4
		EndIf
	EndIf
End Function

Function DrawDragon()
	If DragonDeathTimer>=100 Then Return
	
	If DragonFire=1 Then
		x#=DragonPath(DragonAngle,4)\x
		y#=DragonPath(DragonAngle,4)\y
		mx#=Sin(DragonAngle-80)*15:my#=-Cos(DragonAngle-80)*15
		DrawImage DragonMouthGlow,x+mx,y+my,Rand(0,3)
	EndIf

	For s=1 To 4
		x#=DragonPath(DragonAngle,s)\x
		y#=DragonPath(DragonAngle,s)\y
		If Not s=4 Then DrawImage DragonNeck,x,y Else DrawImage DragonHead(DragonAngle),x,y
	Next
End Function

Function StartNewLevel()
	TrueGameLevel=TrueGameLevel+1
	BonusLevel=0
	GameLevel=0
	GameWon=0
	GameWonTimer=0
	If TrueGameLevel=1 Then GameLevel=1
	If TrueGameLevel=2 Then GameLevel=2
	If TrueGameLevel=3 Then GameLevel=3
	If TrueGameLevel=4 Then BonusLevel=1
	If TrueGameLevel=5 Then GameLevel=4
	If TrueGameLevel=6 Then GameLevel=5
	If TrueGameLevel=7 Then GameLevel=6
	If TrueGameLevel=8 Then BonusLevel=2
	If TrueGameLevel=9 Then GameLevel=7
	If TrueGameLevel=10 Then GameLevel=8
	If TrueGameLevel=11 Then GameLevel=9
	If TrueGameLevel=12 Then BonusLevel=3
	If TrueGameLevel=13 Then GameLevel=10
	
	
	If TrueGameLevel=14 Then GameWon=1
	DragonDeathTimer=0
	LevelDisplayTimer=0
	LevelVictoryTimer=0
	BonusLevelTimer=0
	MusicTimer=1
	level=TrueGameLevel
	NumInPlaceGarg(1)=0
	NumInPlaceGarg(2)=0
	If GameLevel<>0 Then GargoylesLeft=LevelGargsInfo(GameLevel)\Number
	
	For a=1 To MaxParticles
		Particle(a)\exist=0
	Next

	For a=1 To 2
		For b=1 To 4
			If WalkGarg(a,b)\exist=1 Then AddExplosion(WalkGarg(a,b)\x,WalkGarg(a,b)\y,20,2,1,1)
			WalkGarg(a,b)\exist=0
		Next
	Next
End Function

Function PauseGame()
	PauseChannel MusicChannel
	.PauseLoop
	
	kkk=GetKey()
	If kkk=112 Or kkk=80 Then 
		ResumeChannel MusicChannel
		Return
	EndIf
	If KeyDown(1) Then End
	
	Goto Pauseloop
End Function


Function AddFireball()
	If DragonDeathTimer>0 Then Return
	If LevelVictoryTimer>=100 Then Return
	If MusicTimer<3 Then Return
	For a=1 To MaxFireballs
		If Fireball(a)\exist=0 Then
			Fireball(a)\exist=1
			Fireball(a)\x=DragonPath(DragonAngle,4)\x+(Sin(DragonAngle-81)*5)
			Fireball(a)\y=DragonPath(DragonAngle,4)\y-(Cos(DragonAngle-81)*5)
			Fireball(a)\mx=Sin(DragonAngle-81)*FireBallSpeed
			Fireball(a)\my=-Cos(DragonAngle-81)*FireBallSpeed
			Fireball(a)\frame=0
			Fireball(a)\frametimer=0
			Fireball(a)\dying=0
			DragonFire=1
			SoundVolume FireShoot,0.2
			PlaySound FireShoot
			Return
		EndIf
	Next
End Function

Function UpdateFireballs()
	For f=1 To MaxFireballs
		If Fireball(f)\exist=1 Then
			Fireball(f)\x=Fireball(f)\x+Fireball(f)\mx
			Fireball(f)\y=Fireball(f)\y+Fireball(f)\my
			Fireball(f)\frametimer=Fireball(f)\frametimer+1

			If Fireball(f)\frametimer>3 Then
				Fireball(f)\frametimer=0
				Fireball(f)\frame=Fireball(f)\frame+1
			EndIf
			
			If Fireball(f)\frame>5 And Fireball(f)\dying=0 Then Fireball(f)\frame=3
			If Fireball(f)\dying=1 Then
				If Fireball(f)\frame>9 Then 
					Fireball(f)\exist=0
					Fireball(f)\frame=9
				EndIf
			EndIf	

			If Fireball(f)\x>340 Or Fireball(f)\x<-20 Then Fireball(f)\exist=0
			If Fireball(f)\y<-20 Then Fireball(f)\exist=0
			
			;HIT A GARGOYLE?
			
			If Fireball(f)\dying=0 Then
				For g=1 To MaxGargoyles
					If Gargoyle(g)\exist=1 And Gargoyle(g)\flaming=0 And ImagesCollide(Fireballs,Fireball(f)\x,Fireball(f)\y,Fireball(f)\frame,Gargoyles,Gargoyle(g)\x,Gargoyle(g)\y,Gargoyle(g)\frame) Then
						Fireball(f)\dying=1:Fireball(f)\frame=6:Fireball(f)\frametimer=0
						Gargoyle(g)\hp=Gargoyle(g)\hp-1
						If Gargoyle(g)\hp<=0 Then 
							Gargoyle(g)\flaming=1
							Score=Score+1
							
							If ChannelPlaying(GargScreamChannel)=1 Then StopChannel(GargScreamChannel)
							GargScreamChannel=PlaySound(GargoyleScream)
							
							For e=1 To 10
								AddParticle(Gargoyle(g)\x,Gargoyle(g)\y,Rnd(-1,1),Rnd(-1,1),3)
							Next
						EndIf
					EndIf
				Next
			EndIf

			;HIT A BONUS OBJECT?
			
			If Fireball(f)\dying=0 Then
				For b=1 To MaxBonusObj
					If BonusObj(b)\exist=1 Then 
						bonusframe=((BonusObj(b)\typ-1)*5)+BonusObj(b)\frame
						If ImagesCollide(Fireballs,Fireball(f)\x,Fireball(f)\y,Fireball(f)\frame,BonusObjects,BonusObj(b)\x,BonusObj(b)\y,bonusframe) Then
							Fireball(f)\dying=1:Fireball(f)\frame=6:Fireball(f)\frametimer=0
							BonusObj(b)\hp=BonusObj(b)\hp-1
							If BonusObj(b)\hp<=0 Then
								BonusObj(b)\exist=0
								Score=Score+(3*BonusLevel)
								PlaySound LoudFireWork
								If BonusObj(b)\typ>=1 And BonusObj(b)\typ<=4 Then tt=BonusObj(b)\typ+4
								If BonusObj(b)\typ>=13 And BonusObj(b)\typ<=16 Then tt=BonusObj(b)\typ-8
								If BonusObj(b)\typ>=5 And BonusObj(b)\typ<=6 Then tt=5
								If BonusObj(b)\typ>=7 And BonusObj(b)\typ<=8 Then tt=6
								If BonusObj(b)\typ>=9 And BonusObj(b)\typ<=10 Then tt=7
								If BonusObj(b)\typ>=11 And BonusObj(b)\typ<=12 Then tt=8
								
								AddExplosion(BonusObj(b)\x,BonusObj(b)\y,100,3,tt,tt)
							EndIf
						EndIf
					EndIf
				Next
			EndIf

			;HIT A BOMB?
			
			If Fireball(f)\dying=0 Then
				For b=1 To 5
					If Bomb(b)\exist=1 Then
						If ImagesCollide(Fireballs,Fireball(f)\x,Fireball(f)\y,Fireball(f)\frame,WyvernBomb,Bomb(b)\x,Bomb(b)\y,0) Then
							Fireball(f)\dying=1:Fireball(f)\frame=6:Fireball(f)\frametimer=0
							Bomb(b)\hp=Bomb(b)\hp-1
							If Bomb(b)\hp<=0 Then
								Bomb(b)\exist=0
								Score=Score+15
								PlaySound LoudFireWork
								AddExplosion(Bomb(b)\x,Bomb(b)\y,250,3,9,9)
							EndIf
						EndIf
					EndIf
				Next
			EndIf
			
			;HIT A WYVERN?
			
			If Fireball(f)\dying=0 Then
				For w=1 To 5
					If Wyvern(w)\exist=1 And Wyvern(w)\dying=0 Then
						wyvernframe=((Wyvern(w)\dir-1)*6)+Wyvern(w)\frame
						If ImagesCollide(Fireballs,Fireball(f)\x,Fireball(f)\y,Fireball(f)\frame,Wyverns,Wyvern(w)\x,Wyvern(w)\y,wyvernframe) Then
							Fireball(f)\dying=1:Fireball(f)\frame=6:Fireball(f)\frametimer=0
							Wyvern(w)\hp=Wyvern(w)\hp-1
							If Wyvern(w)\hp<=0 Then
								Score=Score+15
								If Wyvern(w)\holdbomb=1 Then
									Wyvern(w)\exist=0
									AddExplosion(Wyvern(w)\x,Wyvern(w)\y,250,3,3,4)
									AddExplosion(Wyvern(w)\x,Wyvern(w)\y,250,3,9,9)
									PlaySound LoudFireWork
								EndIf
								If Wyvern(w)\holdbomb=0 Then
									Wyvern(w)\dying=1
									AddExplosion(Wyvern(w)\x,Wyvern(w)\y,50,3,3,4)
									PlaySound SoftFireWork
								EndIf
							EndIf									
						EndIf
					EndIf
				Next
			EndIf
			
			;HIT A GRYPHON?
			
			If Fireball(f)\dying=0 Then
				For g=1 To 5
					If Gryphon(g)\exist=1 And Gryphon(g)\dying=0 Then
						gryphonframe=((Gryphon(g)\swerve-1)*6)+Gryphon(g)\flapframe
						If ImagesCollide(Fireballs,Fireball(f)\x,Fireball(f)\y,Fireball(f)\frame,Gryphons,Gryphon(g)\x,Gryphon(g)\y,gryphonframe) Then
							Fireball(f)\dying=1:Fireball(f)\frame=6:Fireball(f)\frametimer=0
							Gryphon(g)\hp=Gryphon(g)\hp-1
							If Gryphon(g)\hp<=0 Then
								Gryphon(g)\dying=1
								Score=Score+20
								Gryphon(g)\flapframe=0
								Gryphon(g)\flaptimer=0								
								AddExplosion(Gryphon(g)\x,Gryphon(g)\y,50,3,3,4)
								PlaySound GryphonDeath
							EndIf
						EndIf
					EndIf
				Next
			EndIf
			
			DrawImage Fireballs,Fireball(f)\x+Rand(-2,2),Fireball(f)\y+Rand(-2,2),Fireball(f)\frame
		EndIf
	Next
End Function

Function AddExplosion(x#,y#,numparts,maxspeed#,mintype,maxtype)
	For boom=1 To numparts
		ang=Rand(0,359)
		sp#=Rnd(0,maxspeed)
		ex#=Sin(ang)*sp
		ey#=-Cos(ang)*sp
		AddParticle(x,y,ex,ey,Rand(mintype,maxtype))
	Next		
End Function

Function AddParticle(x#,y#,mx#,my#,typ)
	For p=1 To MaxParticles
		If Particle(p)\exist=0 Then
			Particle(p)\exist=1
			Particle(p)\typ=typ
			Particle(p)\frame=0
			Particle(p)\frametimer=0
			Particle(p)\x=x
			Particle(p)\y=y
			Particle(p)\mx=mx
			Particle(p)\my=my
			Return
		EndIf
	Next
End Function

Function UpdateParticles()
	For p=1 To MaxParticles
		If Particle(p)\exist=1 Then
			Particle(p)\my=Particle(p)\my+Gravity
			Particle(p)\x=Particle(p)\x+Particle(p)\mx
			Particle(p)\y=Particle(p)\y+Particle(p)\my
			Particle(p)\frametimer=Particle(p)\frametimer+1
			If Particle(p)\frametimer>5 Then
				Particle(p)\frametimer=0
				Particle(p)\frame=Particle(p)\frame+1
				If Particle(p)\frame>2 Then Particle(p)\frame=0
			EndIf
			
			If Particle(p)\y>250 Then Particle(p)\exist=0
			If Particle(p)\x>330 Or Particle(p)\x<-10 Then Particle(p)\exist=0
			
			fr=((Particle(p)\typ-1)*3)+Particle(p)\frame
			DrawImage Particles,Particle(p)\x,Particle(p)\y,fr
		
		EndIf
	Next
End Function

Function LevelOver()
;FOR LEVEL TO END, NO MORE GARGOYLES TO DEPLOY AND ALL ENEMIES CLEARED FROM SCREEN (EXCEPT WALK GARGOYLES)
	If LevelVictoryTimer>0 Then Return

	If GameLevel<>0 Then
		count=0
		For g=1 To 200
			count=count+Gargoyle(g)\exist
		Next
		
		If GargoylesLeft=0 And count=0 Then 
			LevelVictoryTimer=1
			For gg=1 To 5
				Wyvern(gg)\dying=1
				Gryphon(gg)\dying=1
			Next
		EndIf
		
		leftside=0:rightside=0
		For a=1 To 4
			leftside=leftside+WalkGarg(1,a)\exist
			rightside=rightside+WalkGarg(2,a)\exist
		Next
		
		If leftside=4 Then LevelVictoryTimer=0
		If rightside=4 Then LevelVictoryTimer=0
		Return
	EndIf
	
	If BonusLevel<>0 Then
		BonusLevelTimer=BonusLevelTimer+1
		If BonusLevelTimer>MaxBonusLevelTimer Then LevelVictoryTimer=1
	EndIf	
	
End Function

Function AddGameLevelGargoyle()
	
	;Return

	If GargoylesLeft<=0 Then Return
	dir=Rand(1,2)
	If dir=1 Then addx=Rand(0,100) Else addx=Rand(219,319)
	ga=AddGargoyle(addx,-10,LevelGargsInfo(GameLevel)\Minspeed,LevelGargsInfo(GameLevel)\Maxspeed)
	If ga=True Then GargoylesLeft=GargoylesLeft-1
End Function

Function AddGargoyle(x#,y#,minmy#,maxmy#)
	If GameLevel=0 Then Return
	For g=1 To MaxGargoyles
		If Gargoyle(g)\exist=0 Then
			Gargoyle(g)\exist=1
			Gargoyle(g)\x=x
			Gargoyle(g)\y=y
			Gargoyle(g)\frame=Rand(0,4)
			Gargoyle(g)\frametimer=0
			Gargoyle(g)\my=Rnd(minmy,maxmy)
			Gargoyle(g)\flaming=0
			Gargoyle(g)\hp=4
			Return True				;SUCCESS!
		EndIf
	Next
	Return False					;NO LUCK
End Function

Function UpdateGargoyles()
	For g=1 To MaxGargoyles
		If Gargoyle(g)\exist=1 Then
			If Gargoyle(g)\flaming=1 Then Gargoyle(g)\my=Gargoyle(g)\my+Gravity
			If Gargoyle(g)\flaming=0 And DragonDeathTimer>0 Then Gargoyle(g)\my=0
			Gargoyle(g)\y=Gargoyle(g)\y+Gargoyle(g)\my
			Gargoyle(g)\frametimer=Gargoyle(g)\frametimer+1
			If Gargoyle(g)\frametimer>=5 Then
				Gargoyle(g)\frametimer=0
				Gargoyle(g)\frame=Gargoyle(g)\frame+1
				If Gargoyle(g)\flaming=0 Then 
					If Gargoyle(g)\frame>4 Then Gargoyle(g)\frame=0
				Else
					If Gargoyle(g)\frame>7 Then Gargoyle(g)\frame=5
				EndIf
			EndIf

			If Gargoyle(g)\y>230 Then
				Gargoyle(g)\exist=0 
				If Gargoyle(g)\flaming=0 Then 
					If Gargoyle(g)\x<=159 Then dir=1 Else dir=2				
					AddWalkingGargoyle(Gargoyle(g)\x,dir)
				EndIf
				If Gargoyle(g)\flaming=1 Then
					For boom=1 To 20
						AddParticle(Gargoyle(g)\x,235,Rnd(-0.5,0.5),Rnd(-2,0),1)
					Next
					PlaySound GargoylePlop
				EndIf
			EndIf
			
			DrawImage Gargoyles,Gargoyle(g)\x,Gargoyle(g)\y,Gargoyle(g)\frame
		EndIf
	Next
End Function

Function AddWalkingGargoyle(x,dir)						;1=Left, 2=Right
	For g=1 To 4
		If WalkGarg(dir,g)\exist=0 Then
			WalkGarg(dir,g)\exist=1
			WalkGarg(dir,g)\x=x
			WalkGarg(dir,g)\y=228
			WalkGarg(dir,g)\inplace=0
			WalkGarg(dir,g)\frame=0
			WalkGarg(dir,g)\frametimer=0
			PlaySound GargoyleLaugh
			Return
		EndIf
	Next
End Function

Function UpdateWalkingGargoyles()
	For dir=1 To 2
		For g=1 To 4
			If WalkGarg(dir,g)\exist=1 Then
				If WalkGarg(dir,g)\inplace=0 Then
					If DragonDeathTimer=0 Then WalkGarg(dir,g)\frametimer=WalkGarg(dir,g)\frametimer+1
					If WalkGarg(dir,g)\frametimer>=5 Then
						WalkGarg(dir,g)\frametimer=0
						If dir=1 Then move=2 Else move=-2
						If LevelVictoryTimer>0 Then move=0
						WalkGarg(dir,g)\x=WalkGarg(dir,g)\x+move
						WalkGarg(dir,g)\frame=WalkGarg(dir,g)\frame+1
						If WalkGarg(dir,g)\frame>3 Then WalkGarg(dir,g)\frame=0
					EndIf
					frame=8+((dir-1)*5)+WalkGarg(dir,g)\frame
				EndIf
				
				;Add "In Place" Gargoyle
				If (dir=1 And WalkGarg(dir,g)\x>=132) Or (dir=2 And WalkGarg(dir,g)\x<=185) Then
					If NumInPlaceGarg(dir)<4 And WalkGarg(dir,g)\inplace=0 Then
						NumInPlaceGarg(dir)=NumInPlaceGarg(dir)+1
						If dir=1 Then WalkGarg(dir,g)\x=132 Else WalkGarg(dir,g)\x=185
						WalkGarg(dir,g)\inplace=1
						WalkGarg(dir,g)\y=228-(13*(NumInPlaceGarg(dir)-1))
						If NumInPlaceGarg(dir)=4 Then
							If dir=1 Then move=9 Else move=-9
							WalkGarg(dir,g)\x=WalkGarg(dir,g)\x+move						
						EndIf
					EndIf				
				EndIf
				
				If WalkGarg(dir,g)\inplace=1 Then frame=12+((dir-1)*5)				
				
				DrawImage Gargoyles,WalkGarg(dir,g)\x,WalkGarg(dir,g)\y,frame
				
				If NumInPlaceGarg(dir)=4 And DragonDeathTimer=0 Then DragonDeathSequenceByGargoyles
			EndIf
		Next
	Next
End Function

Function BigDragonExplosion()
	StopChannel MusicChannel
	PlaySound BigDragonExplosion
	For boom=1 To 1000
		ang=Rand(-60,60):spd#=Rnd(1,5)
		mx#=Sin(ang)*spd
		my#=-Cos(ang)*spd
		AddParticle(139+Rand(0,40),160+Rand(0,50),mx,my,Rand(1,4))
	Next
End Function

Function DragonDeathSequenceByGargoyles()
	If DragonDeathTimer=0 Then DragonDeathTimer=1
	
	If DragonDeathTimer>0 Then
		
		If DragonDeathTimer=1 Then
			StopChannel MusicChannel
			taunt=Rand(1,3)
			If taunt=1 Then PlaySound GargoyleTaunt1
			If taunt=2 Then PlaySound GargoyleTaunt2
			If taunt=3 Then PlaySound GargoyleTaunt3
		EndIf	
		DragonDeathTimer=DragonDeathTimer+1
		
		If DragonDeathTimer=100 Then 
			If DragonDead=0 Then BigDragonExplosion
			DragonDead=1
		EndIf
	EndIf
End Function

Function GameOver()
	If DragonDeathTimer<300 Then Return
	
	DrawImage TextGameOver,49,50
	If DragonDeathTimer=300 Then PlaySound MusicGameOver
	
	If DragonDeathTimer>600 Then
		Color 255,255,255
		Text 35,95,"PRESS SPACE TO PLAY AGAIN"
		Text 70,115,"PRESS ESC TO QUIT"

		If KeyDown(1) Then End
		If KeyDown(57) Then
			Cls
			Flip
			Delay(1000)
			Initialize
			StartNewLevel
		EndIf
	EndIf
End Function

Function GameWon()
	If GameWon=0 Then Return
	
	GameWonTimer=GameWonTimer+1
	If GameWonTimer=1 Then MusicChannel=PlaySound(MusicGameWon)
	
	DrawImage TextWellDone,0,30
	If GameWonTimer>500 Then
		Color 255,255,255
		Text 40,75,"PRESS SPACE TO PLAY AGAIN"
		Text 80,90,"PRESS ESC TO QUIT"
		If KeyDown(57) Then
			StopChannel MusicChannel
			Cls
			Flip
			Delay(1000)
			Initialize
			StartNewLevel
			Return
		EndIf
	EndIf
	
	If GameWonTimer Mod 5=0 And GameWonTimer<=2000 Then
		co=Rand(5,8)
		PlaySound SoftFireWork
		AddExplosion(Rand(0,319),Rand(10,150),100,2,co,co)
	EndIf
	
	If GameWonTimer>=2050 And GameWonTimer<=3000 And GameWonTimer Mod 50=0 Then
		xx=Rand(0,319):yy=Rand(10,100)
		For bb=1 To 5
			co=Rand(5,8)
			AddExplosion(xx,yy,100,3,co,co)
		Next
		PlaySound LoudFireWork
	EndIf
	
	If GameWonTimer>3002 Then GameWonTimer=3002	
	
End Function

Function LevelVictorySequence()
	If LevelVictoryTimer=100 Then StopChannel MusicChannel
	LevelVictoryTimer=LevelVictoryTimer+1
	
	If LevelVictoryTimer=100 Then PlaySound LevelVictorySong
	
	For fw=1 To 20
		If LevelVictoryTimer=320+(5*fw) Then 
			co=Rand(5,8)
			PlaySound SoftFireWork
			AddExplosion(Rand(0,319),Rand(10,150),100,2,co,co)
		EndIf
	Next

	If LevelVictoryTimer=440 Then
		PlaySound LoudFireWork
		AddExplosion(159,80,1500,3,5,8)
	EndIf

	If LevelVictoryTimer>=800 Then StartNewLevel
End Function

Function AddBonusObj(x#,y#,mx#,my#,typ)
	If BonusLevel=0 Then Return
	If LevelVictoryTimer>0 Then Return
	For b=1 To MaxBonusObj
		If BonusObj(b)\exist=0 Then
			BonusObj(b)\exist=1
			BonusObj(b)\x=x
			BonusObj(b)\y=y
			BonusObj(b)\mx=mx
			BonusObj(b)\my=my
			BonusObj(b)\typ=typ
			BonusObj(b)\frame=0
			BonusObj(b)\frametimer=0
			BonusObj(b)\hp=20
			Return
		EndIf
	Next
End Function

Function UpdateBonusObj()
	For b=1 To MaxBonusObj
		If BonusObj(b)\exist=1 Then
			BonusObj(b)\x=BonusObj(b)\x+BonusObj(b)\mx
			BonusObj(b)\y=BonusObj(b)\y+BonusObj(b)\my
				
			If BonusObj(b)\x>380 Or BonusObj(b)\x<-60 Then BonusObj(b)\exist=0
			If BonusObj(b)\y>230 Or BonusObj(b)\y<-60 Then BonusObj(b)\exist=0
			BonusObj(b)\frametimer=BonusObj(b)\frametimer+1
			If BonusObj(b)\frametimer>5 Then
				BonusObj(b)\frametimer=0
				BonusObj(b)\frame=BonusObj(b)\frame+1
				If BonusObj(b)\frame>4 Then BonusObj(b)\frame=0
			EndIf
			
			frame=((BonusObj(b)\typ-1)*5)+BonusObj(b)\frame
			DrawImage BonusObjects,BonusObj(b)\x,BonusObj(b)\y,frame
		EndIf
	Next
End Function

Function AddGameLevelBonusObj()
	If BonusLevel=0 Then Return
	
	If BonusLevel=1 Then
		side=Rand(1,2)
		If Side=1 Then AddBonusObj(340,Rand(10,100),Rnd(-2,-1),0,Rand(1,4))
		If Side=2 Then AddBonusObj(-20,Rand(10,100),Rnd(1,2),0,Rand(1,4))
	EndIf
	
	If BonusLevel=2 Then
		side=Rand(1,2)
		t=5+(Rand(0,3)*2)+(side-1)
		If Side=1 Then AddBonusObj(-20,Rand(30,100),Rnd(1,2),Rnd(-0.1,0.1),t)
		If Side=2 Then AddBonusObj(340,Rand(30,100),Rnd(-2,-1),Rnd(-0.1,0.1),t)
	EndIf
	
	If BonusLevel=3 Then AddBonusObj(Rand(10,309),-20,Rnd(-0.2,0.2),Rnd(0.5,1.3),Rand(13,16))
End Function

Function AddBomb(x#,y#,mx#,my#)
	For b=1 To 5
		If Bomb(b)\exist=0 Then
			Bomb(b)\exist=1
			Bomb(b)\x=x
			Bomb(b)\y=y
			Bomb(b)\mx=mx
			Bomb(b)\my=my
			Bomb(b)\hp=20
			PlaySound FallingBomb
			Return
		EndIf
	Next
End Function

Function UpdateBombs()
	For b=1 To 5
		If Bomb(b)\exist=1 Then
			Bomb(b)\my=Bomb(b)\my+Gravity
			Bomb(b)\x=Bomb(b)\x+Bomb(b)\mx
			Bomb(b)\y=Bomb(b)\y+Bomb(b)\my
			
			;YOU'RE TOAST
			If Bomb(b)\y>200 Then 
				Bomb(b)\exist=0
				If DragonDeathTimer=0 Then DragonDeathTimer=99
			EndIf
				
			
			DrawImage WyvernBomb,Bomb(b)\x,Bomb(b)\y
			
		EndIf
	Next
End Function

Function AddGameLevelWyvern()
	If GameLevel<7 Then Return
	If LevelVictoryTimer>0 Then Return
	If DragonDeathTimer>0 Then Return
	
	dir=Rand(1,2)
	y=Rand(25,50)
	x=-40+(400*(dir-1))
	AddWyvern(x,y,dir)
		
End Function	

;Field x#,y#,hp,frame,frametimer,dir,holdbomb,exist
Function AddWyvern(x,y,dir)					;1=go right, 2=go left
	For w=1 To 1
		If Wyvern(w)\exist=0 Then
			Wyvern(w)\exist=1
			Wyvern(w)\x=x
			Wyvern(w)\y=y
			Wyvern(w)\my=0
			Wyvern(w)\dir=dir
			Wyvern(w)\frame=0
			Wyvern(w)\frametimer=0
			Wyvern(w)\holdbomb=1
			Wyvern(w)\dying=0
			Wyvern(w)\hp=20
			Return
		EndIf
	Next
End Function

Function UpdateWyverns()
	For w=1 To 5
		If Wyvern(w)\exist=1 Then
			move#=1
			If Wyvern(w)\dir=2 Then move=move*-1
			If Wyvern(w)\dying=1 Then Wyvern(w)\my=Wyvern(w)\my+Gravity
			Wyvern(w)\x=Wyvern(w)\x+move
			Wyvern(w)\y=Wyvern(w)\y+Wyvern(w)\my
			Wyvern(w)\frametimer=Wyvern(w)\frametimer+1
			Minframe=0+((Wyvern(w)\dir-1)*6)
			If Wyvern(w)\frametimer>=5 Then
				Wyvern(w)\frametimer=0
				Wyvern(w)\frame=Wyvern(w)\frame+1
				If Wyvern(w)\frame>5 Then Wyvern(w)\frame=0
				If Wyvern(w)\frame>3 And Wyvern(w)\dying=1 Then Wyvern(w)\frame=0
			EndIf
			If Wyvern(w)\x>400 Or Wyvern(w)\x<-80 Then Wyvern(w)\exist=0
			If Wyvern(w)\y>234 Then
				Wyvern(w)\exist=0
				For boom=1 To 100
					AddParticle(Wyvern(w)\x+Rand(-20,20),234,Rnd(-1,1),Rnd(-3,-0.5),Rand(3,4))
				Next
				PlaySound LoudFireWork
			EndIf
			
			If Wyvern(w)\holdbomb=1 Then
				If Wyvern(w)\dir=1 Then DrawImage WyvernBomb,Wyvern(w)\x+1,Wyvern(w)\y+14
				If Wyvern(w)\dir=2 Then DrawImage WyvernBomb,Wyvern(w)\x-2,Wyvern(w)\y+14
			EndIf
			
			If Wyvern(w)\dying=0 Then
				footframe=16+(Wyvern(w)\dir*2)
				If Wyvern(w)\holdbomb=0 Then footframe=footframe+1
				DrawImage Wyverns,Wyvern(w)\x,Wyvern(w)\y,footframe
			EndIf
			
			fr=((Wyvern(w)\dir-1)*6)+Wyvern(w)\frame
			If Wyvern(w)\dying=1 Then fr=12+Wyvern(w)\frame
			DrawImage Wyverns,Wyvern(w)\x,Wyvern(w)\y,fr 
			
			;DROPPING BOMBS!
			If Wyvern(w)\dying=0 Then
				If Wyvern(w)\dir=1 And Wyvern(w)\x>80 And Wyvern(w)\holdbomb=1 And DragonDeathTimer=0 Then
					Wyvern(w)\holdbomb=0
					AddBomb(Wyvern(w)\x+1,Wyvern(w)\y+14,move,0)
				EndIf
				If Wyvern(w)\dir=2 And Wyvern(w)\x<240 And Wyvern(w)\holdbomb=1 And DragonDeathTimer=0 Then
					Wyvern(w)\holdbomb=0
					AddBomb(Wyvern(w)\x-2,Wyvern(w)\y+14,move,0)
				EndIf
			EndIf
							
			
		EndIf
	Next
End Function

;Type GryphonType
;	Field x#,y#,mx#,my#,dying,exist,hp
;	Field flaptimer,flapframe,swerve,swervetimer				;swerve is 1,2,3,4,5
;E;nd Type

Function AddGameLevelGryphon()
	If GameLevel<4 Then Return
	If LevelVictoryTimer>0 Then Return
	If DragonDeathTimer>0 Then Return
	
	y=Rand(40,100)
	x=-40+(400*(Rand(0,1)))
	AddGryphon(x,y,0,Rnd(-0.2,0.2))
End Function	

Function AddGryphon(x,y,mx#,my#)
	For g=1 To 2
		If Gryphon(g)\exist=0 Then
			Gryphon(g)\exist=1
			Gryphon(g)\x=x
			Gryphon(g)\y=y
			Gryphon(g)\mx=mx
			Gryphon(g)\my=my
			Gryphon(g)\dying=0
			Gryphon(g)\hp=100
			Gryphon(g)\flaptimer=0
			Gryphon(g)\flapframe=0
			Gryphon(g)\swerve=3
			Gryphon(g)\swervetimer=0
			Return
		EndIf
	Next
End Function

Function SwerveGryphon(g,dir)
	If Gryphon(g)\exist=0 Then Return
	If Gryphon(g)\swervetimer>=20 Then
		Gryphon(g)\swervetimer=0
		Gryphon(g)\swerve=Gryphon(g)\swerve+dir
		If Gryphon(g)\swerve>5 Then Gryphon(g)\swerve=5
		If Gryphon(g)\swerve<1 Then Gryphon(g)\swerve=1
	EndIf
End Function

Function CenterGryphon(g)
	If Gryphon(g)\exist=0 Then Return
	If Gryphon(g)\swervetimer>=20 Then
		Gryphon(g)\swervetimer=0
		Gryphon(g)\swerve=Gryphon(g)\swerve+dir
		If Gryphon(g)\swerve>3 Then Gryphon(g)\swerve=Gryphon(g)\swerve-1
		If Gryphon(g)\swerve<3 Then Gryphon(g)\swerve=Gryphon(g)\swerve+1
	EndIf
End Function

Function UpdateGryphons()
	For g=1 To 5
		If Gryphon(g)\exist=1 Then
			
			If Gryphon(g)\dying=0 Then
				
				If Rand(1,100)=1 Then PlaySound GryphonSquawk
				
				If Gryphon(g)\x>260 Then 
					Gryphon(g)\mx=Gryphon(g)\mx-0.01
					SwerveGryphon(g,-1)
				EndIf
				If Gryphon(g)\x<60 Then
					Gryphon(g)\mx=Gryphon(g)\mx+0.01
					SwerveGryphon(g,1)
				EndIf
				If Gryphon(g)\y>110 Then Gryphon(g)\my=Gryphon(g)\my-0.02
				If Gryphon(g)\y<40 Then Gryphon(g)\my=Gryphon(g)\my+0.02
			
				If Rand(1,50)=1 And LevelVictoryTimer=0 And DragonDeathTimer=0 Then
					If Gryphon(g)\x>219 And Gryphon(g)\x<300 Then AddGargoyle(Gryphon(g)\x,Gryphon(g)\y,0.5,0.9)
					If Gryphon(g)\x>19 And Gryphon(g)\x<100 Then AddGargoyle(Gryphon(g)\x,Gryphon(g)\y,0.5,0.9)
				EndIf					
			
				Gryphon(g)\swervetimer=Gryphon(g)\swervetimer+1
				If Gryphon(g)\swervetimer>=20 Then Gryphon(g)\swervetimer=20
					
				Gryphon(g)\flaptimer=Gryphon(g)\flaptimer+1
				If Gryphon(g)\flaptimer>=10 Then 
					Gryphon(g)\flaptimer=0
					Gryphon(g)\flapframe=Gryphon(g)\flapframe+1
					If Gryphon(g)\flapframe>5 Then Gryphon(g)\flapframe=0
				EndIf
			
				If Gryphon(g)\mx>1 Then Gryphon(g)\mx=1
				If Gryphon(g)\mx<-1 Then Gryphon(g)\mx=-1
				If Gryphon(g)\my>1 Then Gryphon(g)\my=1
				If Gryphon(g)\my<-1 Then Gryphon(g)\my=-1
			
				fr=((Gryphon(g)\swerve-1)*6)+Gryphon(g)\flapframe			
			EndIf
			
			If Gryphon(g)\dying=1 Then
				Gryphon(g)\my=Gryphon(g)\my+Gravity
				Gryphon(g)\flaptimer=Gryphon(g)\flaptimer+1
				If Gryphon(g)\flaptimer>=5 Then
					Gryphon(g)\flaptimer=0
					Gryphon(g)\flapframe=Gryphon(g)\flapframe+1
					If Gryphon(g)\flapframe>3 Then Gryphon(g)\flapframe=0
				EndIf
				fr=30+Gryphon(g)\flapframe
				If Gryphon(g)\y>=234 Then
					Gryphon(g)\exist=0
					PlaySound LoudFireWork
					For boom=1 To 100
						AddParticle(Gryphon(g)\x+Rand(-20,20),234,Rnd(-1,1),Rnd(-3,-0.5),Rand(3,4))
					Next
				EndIf
			EndIf
			
			Gryphon(g)\x=Gryphon(g)\x+Gryphon(g)\mx
			Gryphon(g)\y=Gryphon(g)\y+Gryphon(g)\my
			
			DrawImage Gryphons,Gryphon(g)\x,Gryphon(g)\y,fr
		EndIf
	Next
End Function